macroScript VertsAligner category:"ScriptAttack" tooltip:"VertsAligner v1.0" Icon: #("TrackViewTools",39) --silentErrors: true
(

fn shapeFilt o = (superClassOf o == Shape)	

on isEnabled return Filters.Is_EPoly()
on execute do (

if selection.count==1 and ((classof selection[1])==PolyMeshObject or (classof selection[1])==Editable_Poly) then (
checkspl=0
checkrowvert=0
obj=selection[1]
vertarr=(obj.EditablePoly.GetSelection #Vertex) as array
if vertarr.count<2 then (checkspl=-1; messagebox ("Select more vertices !")) else (
		tempspl=pickObject message: "Pick Spline" forceListenerFocus:false filter:shapeFilt
		if (isValidNode tempspl) then (
			if (numSplines tempspl)!=1 then checkspl=-2
			)
		else checkspl=-3
case checkspl of (
	(-2): messagebox ("Shape must consist of only one spline !")
	(-3): messagebox ("Pick Shape object next time !")
	)
	)
if checkspl==0 then (
spl=copy tempspl
convertToSplineShape spl
startvert=0
select obj
max modify mode
subobjectlevel=1
--messagebox (vertarr as string)
if (isClosed spl 1) then (checkspl=1)
	endarr=#()
	for v in vertarr do (
	ed=polyop.getEdgesUsingVert obj v
	ve=(polyop.getVertsUsingEdge obj ed) as array
	--deleteItem ve (findItem ve v)
	i=1
	while i<=ve.count do if (findItem vertarr ve[i])==0 then deleteItem ve i else i+=1
	if ve.count==2 then (append endarr v)
	)

if endarr.count==2 then (
	startvert=endarr[1]; d=distance (polyop.getVert obj startvert node: obj) (getKnotPoint spl 1 1)
		d1=distance (polyop.getVert obj endarr[2] node: obj) (getKnotPoint spl 1 1)
		if d1<=d then startvert=endarr[2]
	)
else (
	checkrowvert=1
	startvertspl=getKnotPoint spl 1 1
	startvert=vertarr[1]
	dist=distance startvertspl (polyop.getVert obj startvert node: obj)
	for v in vertarr do (
	d=distance startvertspl (polyop.getVert obj v node: obj)
	if d<dist then (dist=d; startvert=v)
	)
	)
--messagebox (startvert as string)
sortarr=#(); append sortarr startvert
deleteItem vertarr (findItem vertarr startvert)
while vertarr.count>0 do (
	ed=polyop.getEdgesUsingVert obj startvert
	ve=(polyop.getVertsUsingEdge obj ed) as array
	deleteItem ve (findItem ve startvert)
	j=1
	while j<=ve.count do if (findItem vertarr ve[j])==0 then deleteItem ve j else j+=1
	--if ve.count>1 then messagebox("wrong al")
	startvert=ve[1]
	if checkrowvert==1 and sortarr.count==1 then (
		dist=distance (polyop.getVert obj startvert node: obj) (getKnotPoint spl 1 (numKnots spl 1))
		for i=2 to ve.count do (
		d1=distance (polyop.getVert obj ve[i] node: obj) (getKnotPoint spl 1 (numKnots spl 1))
		if d1>dist then (startvert=ve[i]; dist=d1)
		)
	)
	t=(findItem vertarr startvert);  if t>0 then (append sortarr startvert;  deleteItem vertarr t)
	)
--messagebox (sortarr as string)
totlen=0.0; lenarr=#()
for i=1 to (sortarr.count-1) do (
	t=(distance (polyop.getVert obj sortarr[i] node: obj) (polyop.getVert obj sortarr[i+1] node: obj))
	totlen=totlen+t
	append lenarr totlen
	)

if checkrowvert==1 then (
	t=(distance (polyop.getVert obj sortarr[1] node: obj) (polyop.getVert obj sortarr[sortarr.count] node: obj))
	totlen=totlen+t
	append lenarr totlen
	)

for i=1 to lenarr.count do (
	coord=lengthInterp spl (lenarr[i]/totlen)
	if (i+1)<=sortarr.count then polyop.setVert obj sortarr[i+1] coord node: obj
	)
vertspl1=getKnotPoint spl 1 1
vertspl2=getKnotPoint spl 1 (numKnots spl 1)
polyop.setVert obj sortarr[1] vertspl1 node: obj
if checkspl==0 then polyop.setVert obj sortarr[sortarr.count] vertspl2 node: obj
delete spl
)
)

	)
)
--end script
